/*
    This program uses a mutex to avoid the race condition.
*/
#include <stdio.h>    // printf()
#include <unistd.h>   // posix, sleep()
#include <pthread.h>

// global variables
int runFlag = 1;
unsigned int count  = 0;  // this variable is shared by both threads
unsigned int count1 = 0;  // this variable is used only by the first thread
unsigned int count2 = 0;  // this variable is used only by the second thread

pthread_mutex_t mutex;

int main()
{
   void *thread1(void *vargp);  //thread function prototype
 //void *thread2(void *vargp);

   int threadParam1 = 1;  // thread function parameters
   int threadParam2 = 2;

   pthread_t tid1;
   pthread_t tid2;

   // initialize the mutex (in signaled state)
   pthread_mutex_init(&mutex, NULL);

   // create two threads
   printf("race2m: Starting threads\n");
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread1, &threadParam2);

   sleep(2);                     // let the threads run for a while
   runFlag = 0;                  // signal the threads to stop

   pthread_join(tid1, NULL);     // wait for the threads to stop
   pthread_join(tid2, NULL);

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


void *thread1(void *vargp)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
 //   pthread_mutex_lock(&mutex);
      old_count = count;
      new_count = ++count;
 //   pthread_mutex_unlock(&mutex);

      if (new_count - old_count != 1)
      {
         printf("Bingo%d: new_count - old_count = %d\n", *((int*)vargp), new_count-old_count);
	  }

      if (1 == *((int*)vargp))
      {
         count1++;
	  }
      else
      {
         count2++;
	  }
   }
   return NULL;
}//thread1

/*
void *thread2(void *vargp)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      pthread_mutex_lock(&mutex);
      old_count = count;
      new_count = ++count;
      pthread_mutex_unlock(&mutex);

      if (new_count - old_count != 1)
      {
         printf("Bingo2: new_count - old_count = %d\n", new_count-old_count);
	  }
      count2++;
   }
   return NULL;
}//thread2
*/
